<?xml version="1.0"?><!--*-nxml-*-->
<!DOCTYPE manpage SYSTEM "xmltoman.dtd">
<?xml-stylesheet type="text/xsl" href="xmltoman.xsl" ?>

<!-- $Id$ -->

<!--
This file is part of PulseAudio.

PulseAudio is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation; either version 2.1 of the
License, or (at your option) any later version.

PulseAudio is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with PulseAudio; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
USA.
-->

<manpage name="pulse-daemon.conf" section="5" desc="PulseAudio daemon configuration file">

  <synopsis>
    <p><file>~/.pulse/daemon.conf</file></p>

    <p><file>@pulseconfdir@/daemon.conf</file></p>
  </synopsis>

  <description>
    <p>The PulseAudio sound server reads configuration directives from
    a file <file>~/.pulse/daemon.conf</file> on startup, and when that
    file doesn't exist from
    <file>@pulseconfdir@/daemon.conf</file>. Please note that the
    server also reads a configuration script on startup
    <file>default.pa</file> which also contains runtime configuration
    directives.</p>

    <p>The configuration file is a simple collection of variable
    declarations. If the configuration file parser encounters either ;
    or # for it ignores the rest of the line until its end.</p>

    <p>For the settings that take a boolean argument, the values
    <opt>true</opt>, <opt>yes</opt>, <opt>on</opt> and <opt>1</opt>
    are equivalent, resp. <opt>false</opt>, <opt>no</opt>,
    <opt>off</opt>, <opt>0</opt>.</p>

  </description>

  <section name="General Directives">

    <option>
      <p><opt>daemonize= </opt> Daemonize after startup. Takes a
      boolean value, defaults to "no". The <opt>--daemonize</opt>
      command line option takes precedence.</p>
    </option>

    <option>
      <p><opt>fail=</opt> Fail to start up if any of the directives
      in the configuration script <file>default.pa</file>
      fail. Takes a boolean argument, defaults to "yes". The <opt>--fail</opt> command line
      option takes precedence.</p>
    </option>

    <option>
      <p><opt>disallow-module-loading=</opt> Disallow module loading
      after startup. This is a security feature that makes sure that
      no further modules may be loaded into the PulseAudio server
      after startup completed. It is recommended to enable this when
      <opt>system-instance</opt> is enabled. Please note that certain
      features like automatic hot-plug support will not work if this
      option is enabled. Takes a boolean argument, defaults to
      <opt>no</opt>. The <opt>--disallow-module-loading</opt> command line
      option takes precedence.</p>
    </option>

    <option>
      <p><opt>resample-method=</opt> The resampling algorithm to
      use. Use one of <opt>src-sinc-best-quality</opt>,
      <opt>src-sinc-medium-quality</opt>, <opt>src-sinc-fastest</opt>,
      <opt>src-zero-order-hold</opt>, <opt>src-linear</opt>,
      <opt>trivial</opt>, <opt>speex-float-N</opt>,
      <opt>speex-fixed-N</opt>, <opt>ffmpeg</opt>. See the
      documentation of libsamplerate for an explanation for the
      different src- methods. The method <opt>trivial</opt> is the most basic
      algorithm implemented. If you're tight on CPU consider using
      this. On the other hand it has the worst quality of them
      all. The Speex resamplers take an integer quality setting in the
      range 0..9 (bad...good). They exist in two flavours: <opt>fixed</opt> and
      <opt>float</opt>. The former uses fixed point numbers, the latter relies on
      floating point numbers. On most desktop CPUs the float point
      resmampler is a lot faster, and it also offers slightly better
      quality. See the output of <opt>dump-resample-methods</opt> for
      a complete list of all available resamplers. Defaults to
      <opt>speex-float-3</opt>. The <opt>--resample-method</opt>
      command line option takes precedence. Note that some modules
      overwrite or allow overwriting of the resampler to use.</p>
    </option>

    <option>
      <p><opt>disable-remixing=</opt> Never upmix or downmix channels
      to different channel maps. Instead, do a simple name-based
      matching only.</p>
    </option>

    <option>
      <p><opt>use-pid-file=</opt> Create a PID file in
      <file>/tmp/pulse-$USER/pid</file>. Of this is enabled you may
      use commands like <opt>--kill</opt> or <opt>--check</opt>. If
      you are planning to start more than one PulseAudio process per
      user, you better disable this option since it effectively
      disables multiple instances. Takes a boolean argument, defaults
      to <opt>yes</opt>. The <opt>--no-cpu-limit</opt> command line
      option takes precedence.</p>
    </option>

    <option>
      <p><opt>no-cpu-limit=</opt> Do not install the CPU load limiter,
      even on platforms where it is supported. This option is useful
      when debugging/profiling PulseAudio to disable disturbing
      SIGXCPU signals. Takes a boolean argument, defaults to <opt>no</opt>. The
      <opt>--no-cpu-limit</opt> command line argument takes
      precedence.</p>
    </option>


    <option>
      <p><opt>system-instance=</opt> Run the daemon as system-wide
      instance, requires root priviliges. Takes a boolean argument,
      defaults to <opt>no</opt>. The <opt>--system</opt> command line
      argument takes precedence.</p>
    </option>


    <option>
      <p><opt>disable-shm=</opt> Disable data transfer via POSIX
      shared memory. Takes a boolean argument, defaults to
      <opt>no</opt>. The <opt>--disable-shm</opt> command line
      argument takes precedence.</p>
    </option>

  </section>

  <section name="Scheduling">

    <option>
      <p><opt>high-priority=</opt> Renice the daemon after startup to
      become a high-priority process. This a good idea if you
      experience drop-outs during playback. However, this is a certain
      security issue, since it works when called SUID root only, or
      RLIMIT_NICE is used. root is dropped immediately after gaining
      the nice level on startup, thus it is presumably safe. See
      <manref section="1" name="pulseaudio"/> for more
      information. Takes a boolean argument, defaults to "yes". The <opt>--high-priority</opt>
      command line option takes precedence.</p>
    </option>

    <option>
      <p><opt>realtime-scheduling=</opt> Try to acquire SCHED_FIFO
      scheduling for the IO threads. The same security concerns as
      mentioned above apply. However, if PA enters an endless loop,
      realtime scheduling causes a system lockup. Thus, realtime
      scheduling should only be enabled on trusted machines for
      now. Please not that only the IO threads of PulseAudio are made
      real-time. The controlling thread is left a normally scheduled
      thread. Thus enabling the high-priority option is orthogonal.
      See <manref section="1" name="pulseaudio"/> for more
      information. Takes a boolean argument, defaults to "no". The
      <opt>--realtime</opt> command line option takes precedence.</p>
    </option>

    <option>
      <p><opt>realtime-priority=</opt> The realtime priority to
      acquire, if <opt>realtime-scheduling</opt> is enabled. Note: JACK uses 10
      by default, 9 for clients. Thus it is recommended to choose the
      PulseAudio real-time priorities lower. Some PulseAudio threads
      might choose a priority a little lower or higher than the
      specified value. Defaults to "5".</p>
    </option>

    <option>
      <p><opt>nice-level=</opt> The nice level to acquire for the
      daemon, if <opt>high-priority</opt> is enabled. Note: on some
      distributions X11 uses -10 by default. Defaults to -11.</p>
    </option>

  </section>

  <section name="Idle Times">

    <option>
      <p><opt>exit-idle-time=</opt> Terminate the daemon after the
      last client quit and this time in seconds passed. Use a negative value to
      disable this feature. Defaults to -1. The
      <opt>--exit-idle-time</opt> command line option takes
      precedence.</p>
    </option>

    <option>
      <p><opt>module-idle-time=</opt> Unload autoloaded modules after
      being idle for this time in seconds. Defaults to 20. The
      <opt>--module-idle-time</opt> command line option takes
      precedence.</p>
    </option>

    <option>
      <p><opt>scache-idle-time=</opt> Unload autoloaded sample cache
      entries after being idle for this time in seconds. Defaults to
      20. The <opt>--scache-idle-time</opt> command line option takes
      precedence.</p>
    </option>

  </section>

  <section name="Paths">

    <option>
      <p><opt>dl-search-path=</opt> The path were to look for dynamic
      shared objects (DSOs/plugins). You may specify more than one
      path seperated by colons. The default path depends on compile
      time settings. The <opt>--dl-search-path</opt> command line
      option takes precedence. </p>
    </option>

    <option>
      <p><opt>default-script-file=</opt> The default configuration
      script file to load. Specify an empty string for not loading a
      default script file. The default behaviour is to load
      <file>~/.pulse/default.pa</file>, and if that file does not
      exist fall back to the system wide installed version
      <file>@pulseconfdir@/default.pa</file>. If <opt>-n</opt> is
      passed on the command line the default configuration script is
      ignored.</p>
    </option>

  </section>

  <section name="Logging">

    <option>
      <p><opt>log-target=</opt> The default log target. Use either
      <opt>stderr</opt>, <opt>syslog</opt> or <opt>auto</opt>. The
      latter is equivalent to <opt>sylog</opt> in case
      <opt>daemonize</opt> is enabled, otherwise to
      <opt>stderr</opt>. Defaults to <opt>auto</opt>. The
      <opt>--log-target</opt> command line option takes
      precedence.</p>
    </option>

    <option>
      <p><opt>log-level=</opt> Log level, one of <opt>debug</opt>,
      <opt>info</opt>, <opt>notice</opt>, <opt>warning</opt>,
      <opt>error</opt>. Log messages with a lower log level than
      specified here are not logged. Defaults to
      <opt>notice</opt>. The <opt>--log-level</opt> command line
      option takes precedence. The <opt>-v</opt> command line option
      might alter this setting.</p>
    </option>

  </section>

  <section name="Resource Limits">

    <p>See <manref name="getrlimit" section="2"/> for
    more information. Set to -1 if PulseAudio shall not touch the resource
    limit. Not all resource limits are available on all operating
    systems.</p>

    <option>
      <p><opt>rlimit-as</opt> Defaults to -1.</p>
    </option>
    <option>
      <p><opt>rlimit-core</opt> Defaults to -1.</p>
    </option>
    <option>
      <p><opt>rlimit-data</opt> Defaults to -1.</p>
    </option>
    <option>
      <p><opt>rlimit-fsize</opt> Defaults to -1.</p>
    </option>
    <option>
      <p><opt>rlimit-nofile</opt> Defaults to 256.</p>
    </option>
    <option>
      <p><opt>rlimit-stack</opt> Defaults to -1.</p>
    </option>
    <option>
      <p><opt>rlimit-nproc</opt> Defaults to -1.</p>
    </option>
    <option>
      <p><opt>rlimit-memlock</opt> Defaults to 16 KiB. Please note
      that the JACK client libraries may require more locked
      memory.</p>
    </option>
    <option>
      <p><opt>rlimit-nice</opt> Defaults to 31. Please make sure that
      the default nice level as configured with <opt>nice-level</opt>
      fits in this resource limit, if <opt>high-priority</opt> is
      enabled.</p>
    </option>
    <option>
      <p><opt>rlimit-rtprio</opt> Defaults to 9. Please make sure that
      the default real-time priority level as configured with
      <opt>realtime-priority=</opt> fits in this resource limit, if
      <opt>realtime-scheduling</opt> is enabled. The JACK client
      libraries require a real-time prority of 9 by default. </p>
    </option>

  </section>

  <section name="Default Device Settings">

    <p>Most drivers try to open the audio device with these settings
    and then fall back to lower settings. The default settings are CD
    quality: 16bit native endian, 2 channels, 44100 Hz sampling.</p>

    <option>
      <p><opt>default-sample-format=</opt> The default sampling
      format. Specify one of <opt>u8</opt>, <opt>s16le</opt>,
      <opt>s16be</opt>, <opt>float32le</opt>, <opt>float32be</opt>,
      <opt>ulaw</opt>, <opt>alaw</opt>. Depending on the endianess of
      the CPU the formats <opt>s16ne</opt>, <opt>s16re</opt>,
      <opt>float32ne</opt>, <opt>float32re</opt> (for native,
      resp. reverse endian) are available as aliases.</p>
    </option>

    <option>
      <p><opt>default-sample-rate=</opt> The default sample frequency.</p>
    </option>

    <option>
      <p><opt>default-sample-channels</opt> The default number of channels.</p>
    </option>

  </section>

  <section name="Default Fragment Settings">

    <p>Some hardware drivers require the hardware playback buffer to
    be subdivided into several fragments. It is possible to change
    these buffer metrics for machines with high scheduling
    latencies. Not all possible values that may be configured here are
    available in all hardware. The driver will to find the nearest
    setting supported.</p>

    <option>
      <p><opt>default-fragments=</opt> The default number of
      fragments. Defaults to 4.</p>
    </option>
    <option>
      <p><opt>default-fragment-size-msec=</opt>The duration of a
      single fragment. Defaults to 25ms (i.e. the total buffer is thus
      100ms long).</p>
    </option>

  </section>

  <section name="Authors">
    <p>The PulseAudio Developers &lt;@PACKAGE_BUGREPORT@&gt;; PulseAudio is available from <url href="@PACKAGE_URL@"/></p>
  </section>

  <section name="See also">
    <p>
      <manref name="pulse-client.conf" section="5"/>, <manref name="default.pa" section="5"/>, <manref name="pulseaudio" section="1"/>, <manref name="pacmd" section="1"/>
    </p>
  </section>

</manpage>
